declare const Swal: any;

window.addEventListener('load', () => { // jQuery is used:
    const $canvas = jQuery("#My_canvas").get(0) as HTMLCanvasElement; // jQuery access to DOM canvas elem. with 'My_canvas' as id.
    const image = new Image();
    const worker = new Worker("./js/Web_Workers_parallel.js"); // Behind the browser stage, this "parallel" code is that of the worker...
    worker.addEventListener('message', response_from_process_image_by_worker); // Subscription about worker's response...
    function response_from_process_image_by_worker(message: MessageEvent) { // Handler of worker's response...
        Swal.fire({
            text: "Worker just terminated image processing... Show it?",
            title: "<strong>Web Workers</strong>",
            icon: 'info',
            // Reload processed image:
        }).then(() => $canvas.getContext('2d')!.putImageData(message.data, 0, 0));
        worker.terminate(); // Worker is no longer used, 'close' optional statement...
    }

    jQuery(window.document).on("go!", process_image_by_worker); // Wait for image availability...
    function process_image_by_worker() { // Handler of image availability...
        if (window.Worker) // Test if the browser supports Web Workers technology...
            // Instance of 'ImageData' must be sent since it is processable by the new HTML5 structured clone algorithm:
            worker.postMessage($canvas.getContext('2d')!.getImageData(0, 0, $canvas.width, $canvas.height));
    }

    image.onload = () => {
        $canvas.width = image.width;
        $canvas.height = image.height;
        $canvas.getContext('2d')!.drawImage(image, 0, 0); // Image is loaded in canvas...
        jQuery(window.document).trigger("go!"); // Image availability: event triggering in jQuery...
    };
    image.src = "./img/Image.jpg"; // Image load...
});
