self.importScripts("../node_modules/chai/chai.js"); // Reused library requires local-scope load...
declare const chai: any;

function process(image_data: ImageData) {
    const buffer = new Uint32Array(image_data.data.buffer);
    for (let pixel_number = 0; pixel_number < buffer.length; pixel_number++) {
        const alpha = buffer[pixel_number] >>> 24; // Most left byte
        let blue = (buffer[pixel_number] & 0x00FF0000) >> 16;
        let green = (buffer[pixel_number] & 0x0000FF00) >> 8;
        let red = buffer[pixel_number] & 0x000000FF; // Most right byte
// Simplistic image processing:
        blue = ~blue;
        green = ~green;
        // red = ~red;
        buffer[pixel_number] = (alpha << 24) | (blue << 16) | (green << 8) | red;
    }
}

onmessage = function (message: MessageEvent) { // Message from caller thread, i.e., 'worker.postMessage($canvas.getContext('2d').getImageData(0, 0, $canvas.width, $canvas.height));', is received...
    chai.assert.isTrue(message.data instanceof ImageData, "'message.data instanceof ImageData', untrue."); // Check received data
    process(message.data);
    postMessage(message.data); // Response from worker to caller thread...
};
